/*
    Copyright (C) 1995-97 AROS - The Amiga Replacement OS
    $Id: sdivmod32.s,v 1.2 1997/02/03 02:54:49 ldp Exp $

    Desc: signed 32 bit division/modulus functions for Amiga/m68k
    Lang: english
*/

#include "machine.i"

    .globl  AROS_SLIB_ENTRY(SDivMod32,Utility)
    .globl  AROS_SLIB_ENTRY(SDivMod32_020,Utility)

    /* Needed for SDivMod32 */
    .globl  AROS_SLIB_ENTRY(UDivMod32,Utility)

    .type   AROS_SLIB_ENTRY(SDivMod32,Utility),@function
    .type   AROS_SLIB_ENTRY(SDivMod32_020,Utility),@function

AROS_SLIB_ENTRY(SDivMod32_020,Utility):
    divsl.l d1,d1:d0
    rts

/* All we do is remember the sign and get UDivMod32 to do all the work,
    this is actually a bit harder than just changing both, doing the
    division and then changing the other...

    If both are positive, do nothing,
    if one is negative, change both,
    if both are negative, change remainder
*/
AROS_SLIB_ENTRY(SDivMod32,Utility):
    tst.l   d0
    bpl.s   nispos
    neg.l   d0
    tst.l   d1
    bpl.s   nisneg
    neg.l   d1
    bsr.s   AROS_SLIB_ENTRY(UDivMod32,Utility)
    neg.l   d1
    rts
nisneg:
    bsr.s   AROS_SLIB_ENTRY(UDivMod32,Utility)
    neg.l   d1
    neg.l   d0
    rts
nispos:
    tst.l   d1
    bpl.s   AROS_SLIB_ENTRY(UDivMod32,Utility)
    neg.l   d1
    bsr.s   AROS_SLIB_ENTRY(UDivMod32,Utility)
    neg.l   d0
    rts
